
/* --------------------------------------------------------------------------
   A. Veneziani - Programma che memorizza una serie di prodotti
                  ed i relativi prezzi

                  Scritto in C++ Builder 6
   -------------------------------------------------------------------------- */

#include "stdio.h"
#include "string.h"
#include "stdlib.h"

// struttura contenente i dati di un prodotto
struct prodotto {
    char descr_prodotto[100];
    float prezzo;
};

int main()
{
   struct prodotto prd[10];    // vettore di strutture prodotto
   char prodotto[100];     // contiene il nome di un prodotto
   int cc, n_el, trovato;
   float totale;        // serve a calcolare il costo totale di tutti i prodotti

   n_el = 0;    // inizializza il conteggio del numero dei prodotti
   do {
         // svuota il buffer di ingresso (lettura dati)
         fflush(stdin);
         // richiesta e lettura del nome del prodotto
         printf("Indica il prodotto:  ");
         gets(prd[n_el].descr_prodotto);
         // se viene dato nome * non chiede il prezzo ...
         if (strcmp(prd[n_el].descr_prodotto, "*") != 0)
         {
            printf("Indica il prezzo di quel prodotto:  ");
            scanf("%f",&(prd[n_el].prezzo));
            n_el++;
         }
      // ....ed esce dal ciclo 
      } while (strcmp(prd[n_el].descr_prodotto, "*") != 0);

      // inizializza la variabile float per calcolare il costo totale delle merci
      totale = 0;
      // cicla su tutti i prodotti inseriti nel vettore (di strutture)
      // ed effettua la somma di tutti i prezzi
      for (cc = 0; cc < n_el; cc++)
         totale = totale + prd[cc].prezzo;

      // stampa il costo totale delle merci   
      printf("Il totale della spesa e':  %4.2f\n\n", totale);

      // richiede uil nome di un prodotto di cui si desideri
      // conoscere il prezzo
      printf("Dai il prodotto di cui vuoi il prezzo:  ");
      gets(prodotto);

      // inizializza a "false" la variabile che indica che la ricerca ha avuto successo
      trovato = 0;
      // cicla per cercare sul vettore
      for (cc = 0; cc < n_el; cc++)
          // controlla se la descrizione del prodotto coincide
          // con quanto richiesto in input
          if (strcmp(prd[cc].descr_prodotto, prodotto) == 0)
          {
             // se e' cosi', indica il prezzo individuato e
             // setta a "true" il segnalatore di ricerca con successo (trovato)
             printf("Il prezzo del prodotto e':  %4.2f\n\n", prd[cc].prezzo);
             trovato = 1;
          }

      // se nessun prodotto con quel nome e' stato trovato...    
      if (! trovato)  printf("Prodotto richiesto non trovato.\n\n");
          
      system("PAUSE");     // attende una conferma prima di uscire dal programma

      return(0);
}
